OGRE-Next: Ogre::v1::OverlayElement Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::v1::OverlayElement Class Referenceabstract
Core » Overlays

Abstract definition of a 2D element to be displayed in an Overlay. More...

`#include <OgreOverlayElement.h>`

Inheritance diagram for Ogre::v1::OverlayElement:
[legend]

## Public Member Functions
| OverlayElement (const String &name)
| Constructor: do not call direct, use OverlayManager::createElement.
| ~OverlayElement () override
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element.
virtual Real | _getDerivedLeft ()
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop ()
| Gets the 'top' position as derived from own left and that of parents.
Real | _getHeight () const
| Gets the height of this element in relation to the screen (where 1.0 = screen height)
Real | _getLeft () const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)
virtual Real | _getRelativeHeight ()
| Gets the 'height' as derived from own height and metrics mode.
virtual Real | _getRelativeWidth ()
| Gets the 'width' as derived from own width and metrics mode.
Real | _getTop () const
| Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right)
Real | _getWidth () const
| Gets the width of this element in relation to the screen (where 1.0 = screen width)
virtual void | _notifyParent (OverlayContainer *parent, Overlay *overlay)
| Internal method for notifying the GUI element of it's parent and ultimate overlay.
virtual void | _notifyViewport ()
| Internal method to notify the element when the viewport of parent overlay has changed.
virtual void | _positionsOutOfDate ()
| Tell the object to recalculate.
virtual void | _releaseManualHardwareResources ()
| Notifies that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies that hardware resources should be restored.
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width)
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen width)
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width)
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width)
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen width)
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width)
virtual void | _update ()
| Internal method to update the element based on transforms applied.
virtual void | _updateFromParent ()
| Updates this elements transform based on it's parent.
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method to put the contents onto the render queue.
virtual OverlayElement * | clone (const String &instanceName)
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
virtual void | copyFromTemplate (OverlayElement *templateOverlay)
virtual OverlayElement * | findElementAt (Real x, Real y)
| Returns true if xy is within the constraints of the component.
virtual const DisplayString & | getCaption () const
| Gets the caption for this element.
virtual const ColourValue & | getColour () const
| Gets the colour for this element.
Real | getHeight () const
| Gets the height of this element in relation to the screen (where 1.0 = screen height)
virtual GuiHorizontalAlignment | getHorizontalAlignment () const
| Gets the horizontal alignment for this element.
Real | getLeft () const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial () const
| See Renderable.
virtual const String & | getMaterialName () const
| Gets the name of the material this element uses.
virtual GuiMetricsMode | getMetricsMode () const
| Retrieves the current settings of how the element metrics are interpreted.
const String & | getName () const
| Gets the name of this overlay.
OverlayContainer * | getParent ()
| Returns the parent container.
const OverlayElement * | getSourceTemplate () const
| Returns the SourceTemplate for this element.
Real | getTop () const
| Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)
virtual const String & | getTypeName () const =0
| Gets the type name of the element.
virtual GuiVerticalAlignment | getVerticalAlignment () const
| Gets the vertical alignment for this element.
Real | getWidth () const
| Gets the width of this element in relation to the screen (where 1.0 = screen width)
void | getWorldTransforms (Matrix4 *xform) const override
| See Renderable.
virtual void | hide ()
| Hides this element if it was visible.
virtual void | initialise ()=0
| Initialise gui element.
virtual bool | isCloneable () const
virtual bool | isContainer () const
| returns false as this class is not a container type
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible () const
| Returns whether or not the element is visible.
virtual void | setCaption (const DisplayString &text)
| Sets the caption on elements that support it.
virtual void | setCloneable (bool c)
virtual void | setColour (const ColourValue &col)
| Sets the colour on elements that support it.
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).
virtual void | setEnabled (bool b)
void | setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height)
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
void | setLeft (Real left)
| Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)
virtual void | setMaterialName (const String &matName)
| Sets the name of the material this element will use.
virtual void | setMetricsMode (GuiMetricsMode gmm)
| Tells this element how to interpret the position and dimension values it is given.
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height)
void | setTop (Real Top)
| Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
void | setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width)
virtual void | show ()
| Shows this element if it was hidden.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
virtual void | getRenderOperation (v1::RenderOperation &op, bool casterPass)=0
| Gets the render operation required to send this object to the frame buffer.
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Detailed Description

Abstract definition of a 2D element to be displayed in an Overlay.

Remarks
  This class abstracts all the details of a 2D element which will appear in an overlay. In fact, not all OverlayElement instances can be directly added to an Overlay, only those which are OverlayContainer instances (a subclass of this class). OverlayContainer objects can contain any OverlayElement however. This is just to enforce some level of grouping on widgets.

  OverlayElements should be managed using OverlayManager. This class is responsible for instantiating / deleting elements, and also for accepting new types of element from plugins etc.

  Note that positions / dimensions of 2D screen elements are expressed as parametric values (0.0 - 1.0) because this makes them resolution-independent. However, most screen resolutions have an aspect ratio of 1.3333:1 (width : height) so note that in physical pixels 0.5 is wider than it is tall, so a 0.5x0.5 panel will not be square on the screen (but it will take up exactly half the screen in both dimensions).

  Because this class is designed to be extensible, it subclasses from StringInterface so its parameters can be set in a generic way.

## Constructor & Destructor Documentation

## ◆ OverlayElement()

Ogre::v1::OverlayElement::OverlayElement | ( | const String & | name | ) |

Constructor: do not call direct, use OverlayManager::createElement.

Referenced by Ogre::v1::OverlayContainer::_addChild(), Ogre::v1::OverlayContainer::_removeChild(), Ogre::v1::OverlayContainer::addChild(), Ogre::v1::OverlayContainer::addChildImpl(), Ogre::v1::OverlayContainer::clone(), clone(), Ogre::v1::OverlayContainer::copyFromTemplate(), copyFromTemplate(), Ogre::v1::OverlayContainer::findElementAt(), findElementAt(), Ogre::v1::OverlayContainer::getChild(), and getSourceTemplate().

## ◆ ~OverlayElement()

Ogre::v1::OverlayElement::~OverlayElement | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getClippingRegion()

virtual void Ogre::v1::OverlayElement::_getClippingRegion | ( | RealRect & | clippingRegion | ) |
| virtual

Gets the clipping region of the element.

## ◆ _getDerivedLeft()

virtual Real Ogre::v1::OverlayElement::_getDerivedLeft | ( |  | ) |
| virtual

Gets the 'left' position as derived from own left and that of parents.

## ◆ _getDerivedTop()

virtual Real Ogre::v1::OverlayElement::_getDerivedTop | ( |  | ) |
| virtual

Gets the 'top' position as derived from own left and that of parents.

## ◆ _getHeight()

Real Ogre::v1::OverlayElement::_getHeight | ( |  | ) | const
| inline

Gets the height of this element in relation to the screen (where 1.0 = screen height)

## ◆ _getLeft()

Real Ogre::v1::OverlayElement::_getLeft | ( |  | ) | const
| inline

Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ _getRelativeHeight()

virtual Real Ogre::v1::OverlayElement::_getRelativeHeight | ( |  | ) |
| virtual

Gets the 'height' as derived from own height and metrics mode.

## ◆ _getRelativeWidth()

virtual Real Ogre::v1::OverlayElement::_getRelativeWidth | ( |  | ) |
| virtual

Gets the 'width' as derived from own width and metrics mode.

## ◆ _getTop()

Real Ogre::v1::OverlayElement::_getTop | ( |  | ) | const
| inline

Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ _getWidth()

Real Ogre::v1::OverlayElement::_getWidth | ( |  | ) | const
| inline

Gets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ _notifyParent()

virtual void Ogre::v1::OverlayElement::_notifyParent | ( | OverlayContainer * | parent,
|  | Overlay * | overlay )
| virtual

Internal method for notifying the GUI element of it's parent and ultimate overlay.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ _notifyViewport()

virtual void Ogre::v1::OverlayElement::_notifyViewport | ( |  | ) |
| virtual

Internal method to notify the element when the viewport of parent overlay has changed.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ _positionsOutOfDate()

virtual void Ogre::v1::OverlayElement::_positionsOutOfDate | ( |  | ) |
| virtual

Tell the object to recalculate.

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ _releaseManualHardwareResources()

virtual void Ogre::v1::OverlayElement::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtual

Notifies that hardware resources were lost.

Reimplemented in Ogre::v1::BorderPanelOverlayElement, Ogre::v1::PanelOverlayElement, and Ogre::v1::TextAreaOverlayElement.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::v1::OverlayElement::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtual

Notifies that hardware resources should be restored.

Reimplemented in Ogre::v1::BorderPanelOverlayElement, Ogre::v1::PanelOverlayElement, and Ogre::v1::TextAreaOverlayElement.

## ◆ _setDimensions()

void Ogre::v1::OverlayElement::_setDimensions | ( | Real | width,
|  | Real | height )

Sets the width and height of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setHeight()

void Ogre::v1::OverlayElement::_setHeight | ( | Real | height | ) |

Sets the height of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setLeft()

void Ogre::v1::OverlayElement::_setLeft | ( | Real | left | ) |

Sets the left of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setParent()

void Ogre::v1::OverlayElement::_setParent | ( | OverlayContainer * | parent | ) |
| inline

## ◆ _setPosition()

void Ogre::v1::OverlayElement::_setPosition | ( | Real | left,
|  | Real | top )

Sets the left and top of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setTop()

void Ogre::v1::OverlayElement::_setTop | ( | Real | top | ) |

Sets the top of this element in relation to the screen (where 1.0 = screen width)

## ◆ _setWidth()

void Ogre::v1::OverlayElement::_setWidth | ( | Real | width | ) |

Sets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ _update()

virtual void Ogre::v1::OverlayElement::_update | ( |  | ) |
| virtual

Internal method to update the element based on transforms applied.

Reimplemented in Ogre::v1::BorderPanelOverlayElement, Ogre::v1::OverlayContainer, and Ogre::v1::TextAreaOverlayElement.

## ◆ _updateFromParent()

virtual void Ogre::v1::OverlayElement::_updateFromParent | ( |  | ) |
| virtual

Updates this elements transform based on it's parent.

## ◆ _updateRenderQueue()

virtual void Ogre::v1::OverlayElement::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| virtual

Internal method to put the contents onto the render queue.

Reimplemented in Ogre::v1::BorderPanelOverlayElement, Ogre::v1::OverlayContainer, and Ogre::v1::PanelOverlayElement.

## ◆ clone()

virtual OverlayElement * Ogre::v1::OverlayElement::clone | ( | const String & | instanceName | ) |
| virtual

Reimplemented in Ogre::v1::OverlayContainer.

References OverlayElement().

## ◆ contains()

virtual bool Ogre::v1::OverlayElement::contains | ( | Real | x,
|  | Real | y ) const
| virtual

Returns true if xy is within the constraints of the component.

## ◆ copyFromTemplate()

virtual void Ogre::v1::OverlayElement::copyFromTemplate | ( | OverlayElement * | templateOverlay | ) |
| virtual

Reimplemented in Ogre::v1::OverlayContainer.

References OverlayElement().

## ◆ findElementAt()

virtual OverlayElement * Ogre::v1::OverlayElement::findElementAt | ( | Real | x,
|  | Real | y )
| virtual

Returns true if xy is within the constraints of the component.

Reimplemented in Ogre::v1::OverlayContainer.

References OverlayElement().

## ◆ getCaption()

virtual const DisplayString & Ogre::v1::OverlayElement::getCaption | ( |  | ) | const
| virtual

Gets the caption for this element.

## ◆ getColour()

virtual const ColourValue & Ogre::v1::OverlayElement::getColour | ( |  | ) | const
| virtual

Gets the colour for this element.

Reimplemented in Ogre::v1::TextAreaOverlayElement.

## ◆ getHeight()

Real Ogre::v1::OverlayElement::getHeight | ( |  | ) | const

Gets the height of this element in relation to the screen (where 1.0 = screen height)

## ◆ getHorizontalAlignment()

virtual GuiHorizontalAlignment Ogre::v1::OverlayElement::getHorizontalAlignment | ( |  | ) | const
| virtual

Gets the horizontal alignment for this element.

## ◆ getLeft()

Real Ogre::v1::OverlayElement::getLeft | ( |  | ) | const

Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ getLights()

const LightList & Ogre::v1::OverlayElement::getLights | ( |  | ) | const
| inlineoverridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getMaterial()

const MaterialPtr & Ogre::v1::OverlayElement::getMaterial | ( |  | ) | const

See Renderable.

## ◆ getMaterialName()

virtual const String & Ogre::v1::OverlayElement::getMaterialName | ( |  | ) | const
| virtual

Gets the name of the material this element uses.

## ◆ getMetricsMode()

virtual GuiMetricsMode Ogre::v1::OverlayElement::getMetricsMode | ( |  | ) | const
| virtual

Retrieves the current settings of how the element metrics are interpreted.

## ◆ getName()

const String & Ogre::v1::OverlayElement::getName | ( |  | ) | const

Gets the name of this overlay.

Referenced by Ogre::v1::OverlayContainer::_removeChild().

## ◆ getParent()

OverlayContainer * Ogre::v1::OverlayElement::getParent | ( |  | ) |

Returns the parent container.

## ◆ getSourceTemplate()

const OverlayElement * Ogre::v1::OverlayElement::getSourceTemplate | ( |  | ) | const
| inline

Returns the SourceTemplate for this element.

References OverlayElement().

## ◆ getTop()

Real Ogre::v1::OverlayElement::getTop | ( |  | ) | const

Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)

## ◆ getTypeName()

virtual const String & Ogre::v1::OverlayElement::getTypeName | ( |  | ) | const
| pure virtual

Gets the type name of the element.

All concrete subclasses must implement this.

Implemented in Ogre::v1::BorderPanelOverlayElement, Ogre::v1::PanelOverlayElement, and Ogre::v1::TextAreaOverlayElement.

## ◆ getVerticalAlignment()

virtual GuiVerticalAlignment Ogre::v1::OverlayElement::getVerticalAlignment | ( |  | ) | const
| virtual

Gets the vertical alignment for this element.

## ◆ getWidth()

Real Ogre::v1::OverlayElement::getWidth | ( |  | ) | const

Gets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ getWorldTransforms()

void Ogre::v1::OverlayElement::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

See Renderable.

Implements Ogre::Renderable.

## ◆ hide()

virtual void Ogre::v1::OverlayElement::hide | ( |  | ) |
| virtual

Hides this element if it was visible.

## ◆ initialise()

virtual void Ogre::v1::OverlayElement::initialise | ( |  | ) |
| pure virtual

Initialise gui element.

Implemented in Ogre::v1::BorderPanelOverlayElement, Ogre::v1::OverlayContainer, Ogre::v1::PanelOverlayElement, and Ogre::v1::TextAreaOverlayElement.

## ◆ isCloneable()

virtual bool Ogre::v1::OverlayElement::isCloneable | ( |  | ) | const
| inlinevirtual

## ◆ isContainer()

virtual bool Ogre::v1::OverlayElement::isContainer | ( |  | ) | const
| inlinevirtual

returns false as this class is not a container type

Reimplemented in Ogre::v1::OverlayContainer.

## ◆ isEnabled()

bool Ogre::v1::OverlayElement::isEnabled | ( |  | ) | const

## ◆ isKeyEnabled()

virtual bool Ogre::v1::OverlayElement::isKeyEnabled | ( |  | ) | const
| inlinevirtual

## ◆ isVisible()

bool Ogre::v1::OverlayElement::isVisible | ( |  | ) | const

Returns whether or not the element is visible.

## ◆ setCaption()

virtual void Ogre::v1::OverlayElement::setCaption | ( | const DisplayString & | text | ) |
| virtual

Sets the caption on elements that support it.

Remarks
  This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented in Ogre::v1::TextAreaOverlayElement.

## ◆ setCloneable()

virtual void Ogre::v1::OverlayElement::setCloneable | ( | bool | c | ) |
| inlinevirtual

## ◆ setColour()

virtual void Ogre::v1::OverlayElement::setColour | ( | const ColourValue & | col | ) |
| virtual

Sets the colour on elements that support it.

Remarks
  This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented in Ogre::v1::TextAreaOverlayElement.

## ◆ setDimensions()

void Ogre::v1::OverlayElement::setDimensions | ( | Real | width,
|  | Real | height )

Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).

## ◆ setEnabled()

virtual void Ogre::v1::OverlayElement::setEnabled | ( | bool | b | ) |
| virtual

## ◆ setHeight()

void Ogre::v1::OverlayElement::setHeight | ( | Real | height | ) |

Sets the height of this element in relation to the screen (where 1.0 = screen height)

## ◆ setHorizontalAlignment()

virtual void Ogre::v1::OverlayElement::setHorizontalAlignment | ( | GuiHorizontalAlignment | gha | ) |
| virtual

Sets the horizontal origin for this element.

Remarks
  By default, the horizontal origin for a OverlayElement is the left edge of the parent container (or the screen if this is a root element). You can alter this by calling this method, which is especially useful when you want to use pixel-based metrics (see setMetricsMode) since in this mode you can't use relative positioning.

  For example, if you were using GMM_PIXELS metrics mode, and you wanted to place a 30x30 pixel crosshair in the center of the screen, you would use GHA_CENTER with a 'left' property of -15.

  Note that neither GHA_CENTER or GHA_RIGHT alter the position of the element based on it's width, you have to alter the 'left' to a negative number to do that; all this does is establish the origin. This is because this way you can align multiple things in the center and right with different 'left' offsets for maximum flexibility.

## ◆ setLeft()

void Ogre::v1::OverlayElement::setLeft | ( | Real | left | ) |

Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)

## ◆ setMaterialName()

virtual void Ogre::v1::OverlayElement::setMaterialName | ( | const String & | matName | ) |
| virtual

Sets the name of the material this element will use.

Remarks
  Different elements will use different materials. One constant about them all though is that a Material used for a OverlayElement must have it's depth checking set to 'off', which means it always gets rendered on top. OGRE will set this flag for you if necessary. What it does mean though is that you should not use the same Material for rendering OverlayElements as standard scene objects. It's fine to use the same textures, just not the same Material.

Reimplemented in Ogre::v1::PanelOverlayElement, and Ogre::v1::TextAreaOverlayElement.

## ◆ setMetricsMode()

virtual void Ogre::v1::OverlayElement::setMetricsMode | ( | GuiMetricsMode | gmm | ) |
| virtual

Tells this element how to interpret the position and dimension values it is given.

Remarks
  By default, OverlayElements are positioned and sized according to relative dimensions of the screen. This is to ensure portability between different resolutions when you want things to be positioned and sized the same way across all resolutions. However, sometimes you want things to be sized according to fixed pixels. In order to do this, you can call this method with the parameter GMM_PIXELS. Note that if you then want to place your element relative to the center, right or bottom of it's parent, you will need to use the setHorizontalAlignment and setVerticalAlignment methods.

Reimplemented in Ogre::v1::BorderPanelOverlayElement, and Ogre::v1::TextAreaOverlayElement.

## ◆ setPosition()

void Ogre::v1::OverlayElement::setPosition | ( | Real | left,
|  | Real | top )

Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height)

## ◆ setTop()

void Ogre::v1::OverlayElement::setTop | ( | Real | Top | ) |

Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)

## ◆ setVerticalAlignment()

virtual void Ogre::v1::OverlayElement::setVerticalAlignment | ( | GuiVerticalAlignment | gva | ) |
| virtual

Sets the vertical origin for this element.

Remarks
  By default, the vertical origin for a OverlayElement is the top edge of the parent container (or the screen if this is a root element). You can alter this by calling this method, which is especially useful when you want to use pixel-based metrics (see setMetricsMode) since in this mode you can't use relative positioning.

  For example, if you were using GMM_PIXELS metrics mode, and you wanted to place a 30x30 pixel crosshair in the center of the screen, you would use GHA_CENTER with a 'top' property of -15.

  Note that neither GVA_CENTER or GVA_BOTTOM alter the position of the element based on it's height, you have to alter the 'top' to a negative number to do that; all this does is establish the origin. This is because this way you can align multiple things in the center and bottom with different 'top' offsets for maximum flexibility.

## ◆ setWidth()

void Ogre::v1::OverlayElement::setWidth | ( | Real | width | ) |

Sets the width of this element in relation to the screen (where 1.0 = screen width)

## ◆ show()

virtual void Ogre::v1::OverlayElement::show | ( |  | ) |
| virtual

Shows this element if it was hidden.

The documentation for this class was generated from the following file:

- OgreOverlayElement.h